Index: trunk/source/processes/hadronic/cross_sections/src/G4GlauberGribovCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4GlauberGribovCrossSection.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4GlauberGribovCrossSection.cc	(revision 1228)
@@ -355,5 +355,5 @@
   else
   {
-    sigma        = GetHadronNucleonXscPDG(aParticle, A, Z);
+    sigma        = GetHadronNucleonXscNS(aParticle, A, Z);
     cofInelastic = 2.2;
     cofTotal     = 2.0;
@@ -418,5 +418,5 @@
   else
   {
-    sigma        = GetHadronNucleonXscPDG(aParticle, A, Z);
+    sigma        = GetHadronNucleonXscNS(aParticle, A, Z);
     cofInelastic = 2.2;
     cofTotal     = 2.0;
@@ -460,5 +460,5 @@
   else
   {
-    sigma        = GetHadronNucleonXscPDG(aParticle, A, Z);
+    sigma        = GetHadronNucleonXscNS(aParticle, A, Z);
     cofInelastic = 2.2;
     cofTotal     = 2.0;
@@ -1070,6 +1070,8 @@
   else
   {
-    sumInelastic  = Zt*GetHadronNucleonXscMK(aParticle, theProton);
-    sumInelastic += Nt*GetHadronNucleonXscMK(aParticle, theNeutron);    
+    //sumInelastic  = Zt*GetHadronNucleonXscMK(aParticle, theProton);
+    // sumInelastic += Nt*GetHadronNucleonXscMK(aParticle, theNeutron);    
+    sumInelastic  = Zt*GetHadronNucleonXscNS(aParticle, 1.0, 1.0);
+    sumInelastic += Nt*GetHadronNucleonXscNS(aParticle, 1.0, 0.0);    
   } 
   return sumInelastic;
@@ -1289,322 +1291,4 @@
 }
 
-/////////////////////////////////////////////////////////////////////////////////////
-//
-// Returns hadron-nucleon cross-section based on Mikhail Kossov CHIPS parametrisation of
-// data from G4QuasiFreeRatios class
-
-G4double 
-G4GlauberGribovCrossSection::GetHadronNucleonXscMK(const G4DynamicParticle* aParticle, 
-                                          const G4ParticleDefinition* nucleon  )
-{
-  G4int I = -1;
-  G4int PDG = aParticle->GetDefinition()->GetPDGEncoding();
-  G4double totalXsc = 0;
-  G4double elasticXsc = 0;
-  G4double inelasticXsc;
-  // G4int absPDG = std::abs(PDG);
-
-  G4double p = aParticle->GetMomentum().mag()/GeV;
-
-  G4bool F = false;            
-  if(nucleon == theProton)       F = true;
-  else if(nucleon == theNeutron) F = false;
-  else
-  {
-    G4cout << "nucleon is not proton or neutron, return xsc for proton" << G4endl;
-    F = true;
-  }
-
-  G4bool kfl = true;                             // Flag of K0/aK0 oscillation
-  G4bool kf  = false;
-
-  if( PDG == 130 || PDG == 310 )
-  {
-    kf = true;
-    if( G4UniformRand() > .5 ) kfl = false;
-  }
-  if     ( (PDG == 2212 && F) || (PDG == 2112 && !F) ) I = 0; // pp/nn
-  else if( (PDG == 2112 && F) || (PDG == 2212 && !F) ) I = 1; // np/pn
-
-  else if( (PDG == -211 && F) || (PDG == 211  && !F) ) I = 2; // pimp/pipn
-  else if( (PDG == 211  && F) || (PDG ==-211  && !F) ) I = 3; // pipp/pimn
-
-  else if( PDG == -321 || PDG == -311 || ( kf && !kfl ) ) I = 4; // KmN/K0N
-  else if( PDG == 321  || PDG == 311  || ( kf && kfl  ) ) I = 5; // KpN/aK0N
-
-  else if( PDG > 3000 && PDG < 3335)   I = 6;        // @@ for all hyperons - take Lambda
-  else if( PDG < -2000 && PDG > -3335) I = 7;        // @@ for all anti-baryons - anti-p/anti-n
-  else
-  {
-    G4cout<<"MK PDG = "<<PDG
-          <<", while it is defined only for p,n,hyperons,anti-baryons,pi,K/antiK"<<G4endl;
-    G4Exception("G4QuasiFreeRatio::FetchElTot:","22",FatalException,"CHIPScrash");
-  }
-
-  // Each parameter set can have not more than nPoints = 128 parameters
-
-  static const G4double lmi = 3.5;       // min of (lnP-lmi)^2 parabola
-  static const G4double pbe = .0557;     // elastic (lnP-lmi)^2 parabola coefficient
-  static const G4double pbt = .3;        // total (lnP-lmi)^2 parabola coefficient
-  static const G4double pmi = .1;        // Below that fast LE calculation is made
-  static const G4double pma = 1000.;     // Above that fast HE calculation is made
-                  
-  if( p <= 0.)
-  {
-    G4cout<<" p = "<<p<<" is zero or negative"<<G4endl;
-
-    elasticXsc   = 0.;
-    inelasticXsc = 0.;
-    totalXsc     = 0.;
-
-    return totalXsc;
-  }
-  if (!I)                          // pp/nn
-  {
-    if( p < pmi )
-    {
-      G4double p2 = p*p;
-      elasticXsc          = 1./(.00012 + p2*.2);
-      totalXsc          = elasticXsc;
-    }
-    else if(p>pma)
-    {
-      G4double lp  = std::log(p)-lmi;
-      G4double lp2 = lp*lp;
-      elasticXsc  = pbe*lp2 + 6.72;
-      totalXsc    = pbt*lp2 + 38.2;
-    }
-    else
-    {
-      G4double p2  = p*p;
-      G4double LE  = 1./( .00012 + p2*.2);
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double rp2 = 1./p2;
-      elasticXsc  = LE + ( pbe*lp2 + 6.72+32.6/p)/( 1. + rp2/p);
-      totalXsc    = LE + ( pbt*lp2 + 38.2+52.7*rp2)/( 1. + 2.72*rp2*rp2);
-    }
-  }
-  else if( I==1 )                        // np/pn
-  {
-    if( p < pmi )
-    {
-      G4double p2 = p*p;
-      elasticXsc = 1./( .00012 + p2*( .051 + .1*p2));
-      totalXsc   = elasticXsc;
-    }
-    else if( p > pma )
-    {
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      elasticXsc  = pbe*lp2 + 6.72;
-      totalXsc    = pbt*lp2 + 38.2;
-    }
-    else
-    {
-      G4double p2  = p*p;
-      G4double LE  = 1./( .00012 + p2*( .051 + .1*p2 ) );
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double rp2 = 1./p2;
-      elasticXsc  = LE + (pbe*lp2 + 6.72 + 30./p)/( 1. + .49*rp2/p);
-      totalXsc    = LE + (pbt*lp2 + 38.2)/( 1. + .54*rp2*rp2);
-    }
-  }
-  else if( I == 2 )                        // pimp/pipn
-  {
-    G4double lp = std::log(p);
-
-    if(p<pmi)
-    {
-      G4double lr = lp + 1.27;
-      elasticXsc          = 1.53/( lr*lr + .0676);
-      totalXsc          = elasticXsc*3;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double sp  = std::sqrt(p);
-      elasticXsc  = pbe*ld2 + 2.4 + 7./sp;
-      totalXsc    = pbt*ld2 + 22.3 + 12./sp;
-    }
-    else
-    {
-      G4double lr  = lp + 1.27;
-      G4double LE  = 1.53/( lr*lr + .0676);
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double sp  = std::sqrt(p);
-      G4double lm  = lp + .36;
-      G4double md  = lm*lm + .04;
-      G4double lh  = lp - .017;
-      G4double hd  = lh*lh + .0025;
-      elasticXsc  = LE + (pbe*ld2 + 2.4 + 7./sp)/( 1. + .7/p4) + .6/md + .05/hd;
-      totalXsc    = LE*3 + (pbt*ld2 + 22.3 + 12./sp)/(1. + .4/p4) + 1./md + .06/hd;
-    }
-  }
-  else if( I == 3 )                        // pipp/pimn
-  {
-    G4double lp = std::log(p);
-
-    if( p < pmi )
-    {
-      G4double lr  = lp + 1.27;
-      G4double lr2 = lr*lr;
-      elasticXsc  = 13./( lr2 + lr2*lr2 + .0676);
-      totalXsc    = elasticXsc;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double sp  = std::sqrt(p);
-      elasticXsc  = pbe*ld2 + 2.4 + 6./sp;
-      totalXsc    = pbt*ld2 + 22.3 + 5./sp;
-    }
-    else
-    {
-      G4double lr  = lp + 1.27;
-      G4double lr2 = lr*lr;
-      G4double LE  = 13./(lr2 + lr2*lr2 + .0676);
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double sp  = std::sqrt(p);
-      G4double lm  = lp - .32;
-      G4double md  = lm*lm + .0576;
-      elasticXsc  = LE + (pbe*ld2 + 2.4 + 6./sp)/(1. + 3./p4) + .7/md;
-      totalXsc    = LE + (pbt*ld2 + 22.3 + 5./sp)/(1. + 1./p4) + .8/md;
-    }
-  }
-  else if( I == 4 )                        // Kmp/Kmn/K0p/K0n
-  {
-    if( p < pmi)
-    {
-      G4double psp = p*std::sqrt(p);
-      elasticXsc  = 5.2/psp;
-      totalXsc    = 14./psp;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      elasticXsc           = pbe*ld2 + 2.23;
-      totalXsc           = pbt*ld2 + 19.5;
-    }
-    else
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      G4double sp  = std::sqrt(p);
-      G4double psp = p*sp;
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double lm  = p - .39;
-      G4double md  = lm*lm + .000156;
-      G4double lh  = p - 1.;
-      G4double hd  = lh*lh + .0156;
-      elasticXsc  = 5.2/psp + (pbe*ld2 + 2.23)/(1. - .7/sp + .075/p4) + .004/md + .15/hd;
-      totalXsc    = 14./psp + (pbt*ld2 + 19.5)/(1. - .21/sp + .52/p4) + .006/md + .30/hd;
-    }
-  }
-  else if( I == 5 )                        // Kpp/Kpn/aKp/aKn
-  {
-    if( p < pmi )
-    {
-      G4double lr = p - .38;
-      G4double lm = p - 1.;
-      G4double md = lm*lm + .372;   
-      elasticXsc = .7/(lr*lr + .0676) + 2./md;
-      totalXsc   = elasticXsc + .6/md;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      elasticXsc           = pbe*ld2 + 2.23;
-      totalXsc           = pbt*ld2 + 19.5;
-    }
-    else
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      G4double lr  = p - .38;
-      G4double LE  = .7/(lr*lr + .0676);
-      G4double sp  = std::sqrt(p);
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double lm  = p - 1.;
-      G4double md  = lm*lm + .372;
-      elasticXsc  = LE + (pbe*ld2 + 2.23)/(1. - .7/sp + .1/p4) + 2./md;
-      totalXsc    = LE + (pbt*ld2 + 19.5)/(1. + .46/sp + 1.6/p4) + 2.6/md;
-    }
-  }
-  else if( I == 6 )                        // hyperon-N
-  {
-    if( p < pmi )
-    {
-      G4double p2 = p*p;
-      elasticXsc = 1./(.002 + p2*(.12 + p2));
-      totalXsc   = elasticXsc;
-    }
-    else if( p > pma )
-    {
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double sp  = std::sqrt(p);
-      elasticXsc  = (pbe*lp2 + 6.72)/(1. + 2./sp);
-      totalXsc    = (pbt*lp2 + 38.2 + 900./sp)/(1. + 27./sp);
-    }
-    else
-    {
-      G4double p2  = p*p;
-      G4double LE  = 1./(.002 + p2*(.12 + p2));
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double p4  = p2*p2;
-      G4double sp  = std::sqrt(p);
-      elasticXsc  = LE + (pbe*lp2 + 6.72 + 99./p2)/(1. + 2./sp + 2./p4);
-      totalXsc    = LE + (pbt*lp2 + 38.2 + 900./sp)/(1. + 27./sp + 3./p4);
-    }
-  }
-  else if( I == 7 )                        // antibaryon-N
-  {
-    if( p > pma )
-    {
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      elasticXsc  = pbe*lp2 + 6.72;
-      totalXsc    = pbt*lp2 + 38.2;
-    }
-    else
-    {
-      G4double ye  = std::pow(p, 1.25);
-      G4double yt  = std::pow(p, .35);
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      elasticXsc  = 80./(ye + 1.) + pbe*lp2 + 6.72;
-      totalXsc    = (80./yt + .3)/yt +pbt*lp2 + 38.2;
-    }
-  }
-  else
-  {
-    G4cout<<"PDG incoding = "<<I<<" is not defined (0-7)"<<G4endl;
-  
-  }
-  if( elasticXsc > totalXsc ) elasticXsc = totalXsc;
-
-  totalXsc   *= millibarn;
-  elasticXsc *= millibarn;
-  inelasticXsc   = totalXsc - elasticXsc;
-  if (inelasticXsc < 0.) inelasticXsc = 0.;
-
-  return inelasticXsc;
-}
-
 ////////////////////////////////////////////////////////////////////////////////////
 //
@@ -1618,5 +1302,4 @@
   G4double oneThird = 1.0/3.0;
   G4double cubicrAt = std::pow (At, oneThird); 
-
 
   G4double R;  // = fRadiusConst*cubicrAt;
@@ -1638,8 +1321,4 @@
   R = fRadiusConst*cubicrAt;
 
-  // return R;  // !!!!
-
-
-  
   G4double meanA  = 21.;
 
@@ -1679,5 +1358,4 @@
   G4double cubicrAt = std::pow (At, oneThird); 
 
-
   G4double R;  // = fRadiusConst*cubicrAt;
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronCaptureDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronCaptureDataSet.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronCaptureDataSet.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronCaptureDataSet.cc,v 1.8 2006/06/29 19:57:35 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronCrossSections.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronElasticDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronElasticDataSet.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronElasticDataSet.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronElasticDataSet.cc,v 1.8 2006/06/29 19:57:39 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronFissionDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronFissionDataSet.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronFissionDataSet.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronFissionDataSet.cc,v 1.8 2006/06/29 19:57:41 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronInelasticDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronInelasticDataSet.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronInelasticDataSet.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HadronInelasticDataSet.cc,v 1.8 2006/06/29 19:57:43 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4HadronNucleonXsc.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4HadronNucleonXsc.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4HadronNucleonXsc.cc	(revision 1228)
@@ -883,325 +883,4 @@
 }
 
-/////////////////////////////////////////////////////////////////////////////////////
-//
-// Returns hadron-nucleon cross-section based on Mikhail Kossov parametrisation of
-// data from G4QuasiFreeRatios class
-
-G4double 
-G4HadronNucleonXsc::GetHadronNucleonXscMK(const G4DynamicParticle* aParticle, 
-                                          const G4ParticleDefinition* nucleon  )
-{
-  G4int I = -1;
-  G4int PDG = aParticle->GetDefinition()->GetPDGEncoding();
-
-  // G4int absPDG = std::abs(PDG);
-
-  G4double p = aParticle->GetMomentum().mag()/GeV;
-
-  G4bool F = false;            
-  if(nucleon == theProton)       F = true;
-  else if(nucleon == theNeutron) F = false;
-  else
-  {
-    G4cout << "nucleon is not proton or neutron, return xsc for proton" << G4endl;
-    F = true;
-  }
-
-  G4bool kfl = true;                             // Flag of K0/aK0 oscillation
-  G4bool kf  = false;
-
-  if( PDG == 130 || PDG == 310 )
-  {
-    kf = true;
-    if( G4UniformRand() > .5 ) kfl = false;
-  }
-  if     ( (PDG == 2212 && F) || (PDG == 2112 && !F) ) I = 0; // pp/nn
-  else if( (PDG == 2112 && F) || (PDG == 2212 && !F) ) I = 1; // np/pn
-
-  else if( (PDG == -211 && F) || (PDG == 211  && !F) ) I = 2; // pimp/pipn
-  else if( (PDG == 211  && F) || (PDG ==-211  && !F) ) I = 3; // pipp/pimn
-
-  else if( PDG == -321 || PDG == -311 || ( kf && !kfl ) ) I = 4; // KmN/K0N
-  else if( PDG == 321  || PDG == 311  || ( kf && kfl  ) ) I = 5; // KpN/aK0N
-
-  else if( PDG > 3000 && PDG < 3335)   I = 6;        // @@ for all hyperons - take Lambda
-  else if( PDG < -2000 && PDG > -3335) I = 7;        // @@ for all anti-baryons - anti-p/anti-n
-  else
-  {
-    G4cout<<"MK PDG = "<<PDG
-          <<", while it is defined only for p,n,hyperons,anti-baryons,pi,K/antiK"<<G4endl;
-    G4Exception("G4QuasiFreeRatio::FetchElTot:","22",FatalException,"CHIPScrash");
-  }
-
-  // Each parameter set can have not more than nPoints = 128 parameters
-
-  static const G4double lmi = 3.5;       // min of (lnP-lmi)^2 parabola
-  static const G4double pbe = .0557;     // elastic (lnP-lmi)^2 parabola coefficient
-  static const G4double pbt = .3;        // total (lnP-lmi)^2 parabola coefficient
-  static const G4double pmi = .1;        // Below that fast LE calculation is made
-  static const G4double pma = 1000.;     // Above that fast HE calculation is made
-                  
-  if( p <= 0.)
-  {
-    G4cout<<" p = "<<p<<" is zero or negative"<<G4endl;
-
-    fElasticXsc   = 0.;
-    fInelasticXsc = 0.;
-    fTotalXsc     = 0.;
-
-    return fTotalXsc;
-  }
-  if (!I)                          // pp/nn
-  {
-    if( p < pmi )
-    {
-      G4double p2 = p*p;
-      fElasticXsc          = 1./(.00012 + p2*.2);
-      fTotalXsc          = fElasticXsc;
-    }
-    else if(p>pma)
-    {
-      G4double lp  = std::log(p)-lmi;
-      G4double lp2 = lp*lp;
-      fElasticXsc  = pbe*lp2 + 6.72;
-      fTotalXsc    = pbt*lp2 + 38.2;
-    }
-    else
-    {
-      G4double p2  = p*p;
-      G4double LE  = 1./( .00012 + p2*.2);
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double rp2 = 1./p2;
-      fElasticXsc  = LE + ( pbe*lp2 + 6.72+32.6/p)/( 1. + rp2/p);
-      fTotalXsc    = LE + ( pbt*lp2 + 38.2+52.7*rp2)/( 1. + 2.72*rp2*rp2);
-    }
-  }
-  else if( I==1 )                        // np/pn
-  {
-    if( p < pmi )
-    {
-      G4double p2 = p*p;
-      fElasticXsc = 1./( .00012 + p2*( .051 + .1*p2));
-      fTotalXsc   = fElasticXsc;
-    }
-    else if( p > pma )
-    {
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      fElasticXsc  = pbe*lp2 + 6.72;
-      fTotalXsc    = pbt*lp2 + 38.2;
-    }
-    else
-    {
-      G4double p2  = p*p;
-      G4double LE  = 1./( .00012 + p2*( .051 + .1*p2 ) );
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double rp2 = 1./p2;
-      fElasticXsc  = LE + (pbe*lp2 + 6.72 + 30./p)/( 1. + .49*rp2/p);
-      fTotalXsc    = LE + (pbt*lp2 + 38.2)/( 1. + .54*rp2*rp2);
-    }
-  }
-  else if( I == 2 )                        // pimp/pipn
-  {
-    G4double lp = std::log(p);
-
-    if(p<pmi)
-    {
-      G4double lr = lp + 1.27;
-      fElasticXsc          = 1.53/( lr*lr + .0676);
-      fTotalXsc          = fElasticXsc*3;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double sp  = std::sqrt(p);
-      fElasticXsc  = pbe*ld2 + 2.4 + 7./sp;
-      fTotalXsc    = pbt*ld2 + 22.3 + 12./sp;
-    }
-    else
-    {
-      G4double lr  = lp + 1.27;
-      G4double LE  = 1.53/( lr*lr + .0676);
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double sp  = std::sqrt(p);
-      G4double lm  = lp + .36;
-      G4double md  = lm*lm + .04;
-      G4double lh  = lp - .017;
-      G4double hd  = lh*lh + .0025;
-      fElasticXsc  = LE + (pbe*ld2 + 2.4 + 7./sp)/( 1. + .7/p4) + .6/md + .05/hd;
-      fTotalXsc    = LE*3 + (pbt*ld2 + 22.3 + 12./sp)/(1. + .4/p4) + 1./md + .06/hd;
-    }
-  }
-  else if( I == 3 )                        // pipp/pimn
-  {
-    G4double lp = std::log(p);
-
-    if( p < pmi )
-    {
-      G4double lr  = lp + 1.27;
-      G4double lr2 = lr*lr;
-      fElasticXsc  = 13./( lr2 + lr2*lr2 + .0676);
-      fTotalXsc    = fElasticXsc;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double sp  = std::sqrt(p);
-      fElasticXsc  = pbe*ld2 + 2.4 + 6./sp;
-      fTotalXsc    = pbt*ld2 + 22.3 + 5./sp;
-    }
-    else
-    {
-      G4double lr  = lp + 1.27;
-      G4double lr2 = lr*lr;
-      G4double LE  = 13./(lr2 + lr2*lr2 + .0676);
-      G4double ld  = lp - lmi;
-      G4double ld2 = ld*ld;
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double sp  = std::sqrt(p);
-      G4double lm  = lp - .32;
-      G4double md  = lm*lm + .0576;
-      fElasticXsc  = LE + (pbe*ld2 + 2.4 + 6./sp)/(1. + 3./p4) + .7/md;
-      fTotalXsc    = LE + (pbt*ld2 + 22.3 + 5./sp)/(1. + 1./p4) + .8/md;
-    }
-  }
-  else if( I == 4 )                        // Kmp/Kmn/K0p/K0n
-  {
-    if( p < pmi)
-    {
-      G4double psp = p*std::sqrt(p);
-      fElasticXsc  = 5.2/psp;
-      fTotalXsc    = 14./psp;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      fElasticXsc           = pbe*ld2 + 2.23;
-      fTotalXsc           = pbt*ld2 + 19.5;
-    }
-    else
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      G4double sp  = std::sqrt(p);
-      G4double psp = p*sp;
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double lm  = p - .39;
-      G4double md  = lm*lm + .000156;
-      G4double lh  = p - 1.;
-      G4double hd  = lh*lh + .0156;
-      fElasticXsc  = 5.2/psp + (pbe*ld2 + 2.23)/(1. - .7/sp + .075/p4) + .004/md + .15/hd;
-      fTotalXsc    = 14./psp + (pbt*ld2 + 19.5)/(1. - .21/sp + .52/p4) + .006/md + .30/hd;
-    }
-  }
-  else if( I == 5 )                        // Kpp/Kpn/aKp/aKn
-  {
-    if( p < pmi )
-    {
-      G4double lr = p - .38;
-      G4double lm = p - 1.;
-      G4double md = lm*lm + .372;   
-      fElasticXsc = .7/(lr*lr + .0676) + 2./md;
-      fTotalXsc   = fElasticXsc + .6/md;
-    }
-    else if( p > pma )
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      fElasticXsc           = pbe*ld2 + 2.23;
-      fTotalXsc           = pbt*ld2 + 19.5;
-    }
-    else
-    {
-      G4double ld  = std::log(p) - lmi;
-      G4double ld2 = ld*ld;
-      G4double lr  = p - .38;
-      G4double LE  = .7/(lr*lr + .0676);
-      G4double sp  = std::sqrt(p);
-      G4double p2  = p*p;
-      G4double p4  = p2*p2;
-      G4double lm  = p - 1.;
-      G4double md  = lm*lm + .372;
-      fElasticXsc  = LE + (pbe*ld2 + 2.23)/(1. - .7/sp + .1/p4) + 2./md;
-      fTotalXsc    = LE + (pbt*ld2 + 19.5)/(1. + .46/sp + 1.6/p4) + 2.6/md;
-    }
-  }
-  else if( I == 6 )                        // hyperon-N
-  {
-    if( p < pmi )
-    {
-      G4double p2 = p*p;
-      fElasticXsc = 1./(.002 + p2*(.12 + p2));
-      fTotalXsc   = fElasticXsc;
-    }
-    else if( p > pma )
-    {
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double sp  = std::sqrt(p);
-      fElasticXsc  = (pbe*lp2 + 6.72)/(1. + 2./sp);
-      fTotalXsc    = (pbt*lp2 + 38.2 + 900./sp)/(1. + 27./sp);
-    }
-    else
-    {
-      G4double p2  = p*p;
-      G4double LE  = 1./(.002 + p2*(.12 + p2));
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      G4double p4  = p2*p2;
-      G4double sp  = std::sqrt(p);
-      fElasticXsc  = LE + (pbe*lp2 + 6.72 + 99./p2)/(1. + 2./sp + 2./p4);
-      fTotalXsc    = LE + (pbt*lp2 + 38.2 + 900./sp)/(1. + 27./sp + 3./p4);
-    }
-  }
-  else if( I == 7 )                        // antibaryon-N
-  {
-    if( p > pma )
-    {
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      fElasticXsc  = pbe*lp2 + 6.72;
-      fTotalXsc    = pbt*lp2 + 38.2;
-    }
-    else
-    {
-      G4double ye  = std::pow(p, 1.25);
-      G4double yt  = std::pow(p, .35);
-      G4double lp  = std::log(p) - lmi;
-      G4double lp2 = lp*lp;
-      fElasticXsc  = 80./(ye + 1.) + pbe*lp2 + 6.72;
-      fTotalXsc    = (80./yt + .3)/yt +pbt*lp2 + 38.2;
-    }
-  }
-  else
-  {
-    G4cout<<"PDG incoding = "<<I<<" is not defined (0-7)"<<G4endl;
-  
-  }
-  if( fElasticXsc > fTotalXsc ) fElasticXsc = fTotalXsc;
-
-  fTotalXsc   *= millibarn;
-  fElasticXsc *= millibarn;
-  fInelasticXsc   = fTotalXsc - fElasticXsc;
-  if (fInelasticXsc < 0.) fInelasticXsc = 0.;
-
-
-  return fTotalXsc;
-}
-
-
-
-
-
 ////////////////////////////////////////////////////////////////////////////////////
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronCaptureXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronCaptureXS.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronCaptureXS.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4NeutronCaptureXS.cc,v 1.2 2009/11/19 12:36:53 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronElasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronElasticXS.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronElasticXS.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4NeutronElasticXS.cc,v 1.3 2009/11/19 12:01:54 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticCrossSection.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticCrossSection.cc	(revision 1228)
@@ -26,4 +26,5 @@
 // By JPW, working, but to be cleaned up. @@@
 // 22 Dec 2006 - DHW added isotope dependence
+// G.Folger, 25-Nov-2009: extend to 100TeV, using a constant above 20GeV
 //
 
@@ -64,4 +65,8 @@
 GetCrossSection(G4double anEnergy, G4double atomicNumber, G4double nOfProtons)
 {
+  if (anEnergy > 19.9*GeV ) 
+  { // constant cross section above ~20GeV.
+    return  GetCrossSection(19.8*GeV,atomicNumber,nOfProtons);
+  } 
   G4double kineticEnergy = std::log10(DBL_MIN/MeV);
   if (anEnergy > DBL_MIN/MeV) kineticEnergy = std::log10(anEnergy/MeV);
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticXS.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticXS.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4NeutronInelasticXS.cc,v 1.3 2009/11/19 12:00:40 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PhotoNuclearCrossSection.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // The lust update: M.V. Kossov, CERN/ITEP(Moscow) 17-June-02
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/cross_sections/src/G4PiData.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PiData.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PiData.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4PiNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PiNuclearCrossSection.cc	(revision 1227)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PiNuclearCrossSection.cc	(revision 1228)
@@ -43,5 +43,5 @@
   .02, .04, .06, .08,  .1, .12, .13, .14, .15, .16, .17, .18, .19, .20, 
   .22, .24, .26, .28, .30, .35, .40, .45,  0.5, 0.55, 0.6, 0.7,  0.8,  0.9,
-   1,   2,   3,   5,  10,   20,   50,  100,  500, 1000};
+   1,   2,   3,   5,  10,   20,   50,  100,  500, 100000};
 
  const G4double G4PiNuclearCrossSection::he_t[38] = { 
@@ -76,5 +76,5 @@
   .02, .04, .06, .08, .10, .11, .12, .13, .14,  .15, .16, .17, .18, .20, .22,
   .24, .26, .28, .30, .35, .40, .45, .50, .55, .575, .60, .70, .80, .90,   1,   
-    2,   3,   5,  10,  20,  50, 100, 500, 1000};
+    2,   3,   5,  10,  20,  50, 100, 500, 100000};
 
  const G4double G4PiNuclearCrossSection::c_m_t[39] = {
@@ -117,5 +117,5 @@
   .02, .04, .06, .08, .10, .12, .14, .16, .18, .20, .22, .25, .30, .35, .40, 
   .45, .50, .60, .70, .80, .90,   1,   2,   3,   5,  10,  20,  50, 100, 500, 
-  1000};
+  100000};
 
  const G4double G4PiNuclearCrossSection::o_m_t[31] = {
@@ -158,5 +158,5 @@
   0.02, 0.04, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25, 0.30, 0.35, 0.40,
   0.45, 0.50, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,   20,   50,  100,  500,
-  1000};
+  100000};
 
  const G4double G4PiNuclearCrossSection::al_m_t[31] = { 
@@ -200,5 +200,5 @@
   0.02, 0.04, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25, 0.30, 0.35, 0.40, 
   0.45, 0.50, 0.55, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,   20,   50,  100,
-   500, 1000};
+   500, 100000};
 
  const G4double G4PiNuclearCrossSection::fe_m_t[32] = {1175, 1363, 1670, 1950, 2050, 2040, 1975, 1886, 1834, 1773, 1720, 1635, 1474, 1380, 1269, 1225, 1182, 1162, 1159, 1162, 1178, 1190, 1197, 1102, 1135,  975,  945,  925,  905,  905,  905,  905};
@@ -214,5 +214,5 @@
   0.02, 0.04, 0.05, 0.06, 0.07, 0.08, 0.09, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25,
   0.30, 0.35, 0.40, 0.45, 0.50, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,   20,
-    50,  100,  500, 1000};
+    50,  100,  500, 100000};
 
  const G4double G4PiNuclearCrossSection::mo_m_t[34] = {2430, 2610, 2710, 2790, 2880, 2940, 2965, 2970, 2970, 2920, 2840, 2720, 2570, 2500, 2365, 2200, 2050, 1926, 1825, 1768, 1749, 1750, 1778, 1789, 1808, 1690, 1645, 1530, 1492, 1450, 1425, 1425, 1425, 1425};
@@ -228,5 +228,5 @@
   0.02, 0.04, 0.05, 0.06, 0.07, 0.08, 0.09, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25,  
   0.30, 0.35, 0.40, 0.45, 0.50, 0.55, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,   
-    20,   50,  100,  500, 1000};
+    20,   50,  100,  500, 100000};
 
  const G4double G4PiNuclearCrossSection::sn_m_t[35] =  {3000, 3180, 3250, 3300, 3300, 3410, 3470, 3450, 3410, 3350, 3280, 3200, 3120, 3050, 2900, 2630, 2500, 2325, 2190, 2100, 2060, 2055, 2055, 2055, 2067, 2085, 2000, 1900, 1835, 1770, 1720, 1700, 1695, 1695, 1695};
@@ -242,5 +242,5 @@
   0.02, 0.04, 0.05, 0.06, 0.07, 0.08, 0.09, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20, 0.22, 0.25, 
   0.30, 0.35, 0.40, 0.45, 0.50, 0.55, 0.60, 0.70, 0.80, 0.90,    1,    2,    3,    5,   10,
-    20,   50,  100,  500, 1000};
+    20,   50,  100,  500, 100000};
 
  const G4double G4PiNuclearCrossSection::pb_m_t[35] = {
